UDPIPE=require 'UDPIPEVERBOSE'
UDPROXY=require 'UDPROXY'

MyConnection=class(UDPIPE, function(self, ...)
  UDPIPE.init(self, ...)
end)

local GS -- local copy of GameState
local ClientGameLogic

function MyConnection:onConnect(a, b, c)
  print('MC ON CONNECT:', a, b, c)
  ClientGameLogic:login(ClientGameLogic._username, ClientGameLogic._password)
  ClientGameLogic:getGameState(true)
end

function MyConnection:onUnstalled(sock)
  ClientGameLogic:login(ClientGameLogic._username, ClientGameLogic._password) -- in case the server was restarted
  ClientGameLogic:getGameState(true) -- update to the current game state
end

conn=MyConnection()
conn:connect('127.0.0.1', 1111)

ClientGameLogic=UDPROXY(conn)

function ClientGameLogic:setUser(username, password)
  self._username=username
  self._password=password
end

function ClientGameLogic:getGameState(force)
  if not GS or force then
    GS=GS or {Walls={}, Players={}, Msgs={{'system', 'initializing...'}}} -- fake GameState
    conn:send('getGameState')
  end
  return GS
end

function ClientGameLogic:getSentPackets()
  return conn:getSentPackets()
end

function ClientGameLogic:getReceivedPackets()
  return conn:getReceivedPackets()
end


-------------------

function ClientGameLogic:ongetGameState(gs)
  GS=gs
  CACHED=nil
end

function ClientGameLogic:onPlayerUpdated(P)
  local name=P.name
  local LocalPlayer=GS.Players[name]
  if LocalPlayer then
    for k,v in pairs(P) do LocalPlayer[k]=v end
  else
    print('No player '..name..' in local GameState, I\'d better get the new state from the server')
    self:getGameState(true)
  end
  if P.name==username and LASTMOVE then LASTMOVE=nil end
  CACHED=nil
end

function ClientGameLogic:onAddPlayer(P)
  if GS.Players[P.name] then
    print('Warning: not adding already existing player!')
  else
    GS.Players[P.name]=P
  end
  CACHED=nil
end

function ClientGameLogic:onRemovePlayer(name)
  if GS.Players[name] then
    GS.Players[name]=nil
  else
    print('Warning: not removing nonexisting player!')
  end
  CACHED=nil
end

function ClientGameLogic:onSay(P)
  table.insert(GS.Msgs, {P.name, P.msg})
  if #GS.Msgs>5 then table.remove(GS.Msgs, 1) end
  CACHED=nil
end

return ClientGameLogic
